#include "stdafx.h"
#include "MglDirectInputDeviceBase.h"

#define PRESSKEY(DIK_CODE)	(DIK_CODE & 0x80)

//	RXgN^
CMglDirectInputDeviceBase::CMglDirectInputDeviceBase()
{
	m_pDevice = NULL;
	//ZeroMemory( m_stateBuf, sizeof(m_stateBuf) );
	m_pStateBuf = NULL;
	m_pStateBuf2 = NULL;
	m_nStateBufSize = 0;
	m_hWnd = NULL;
}

//	fXgN^
CMglDirectInputDeviceBase::~CMglDirectInputDeviceBase()
{
	Release();
	//if ( m_pStateBuf != m_pStateBuf2 )
	//	SAFE_DELETE_ARY(m_pStateBuf2);
	SAFE_DELETE_ARY(m_pStateBuf);
	SAFE_DELETE_ARY(m_pStateBuf2);
}

//	
void CMglDirectInputDeviceBase::Init( REFGUID rguid, LPCDIDATAFORMAT dataFormat, int nStateBufSize, HWND hWnd, DWORD dwCooperativeFlag )
{
	//	ꏉ
	InitBase();

	//	ftHghWnd擾
	if ( hWnd == NULL )
		hWnd = GetDefaultHwnd();

	MyuAssert( m_pDi->CreateDevice( rguid, &m_pDevice, NULL ), DI_OK,
		"CMglDirectInputDeviceBase::Init  m_pDi->CreateDevice()Ɏs" );

	MyuAssert( m_pDevice->SetDataFormat( dataFormat ), DI_OK,
		"CMglDirectInputDeviceBase::Init  m_pDevice->SetDataFormat()Ɏs" );
    
	MyuAssert( m_pDevice->SetCooperativeLevel( hWnd, dwCooperativeFlag ), DI_OK,
		"CMglDirectInputDeviceBase::Init  m_pDevice->SetCooperativeLevel()Ɏs" );

	//	Xe[gobt@m
	m_pStateBuf = new BYTE[nStateBufSize];
	m_pStateBuf2 = new BYTE[nStateBufSize];
	m_nStateBufSize = nStateBufSize;
	ZeroMemory(m_pStateBuf,nStateBufSize);		//	2008/06/29  ĂȂłǁII
	ZeroMemory(m_pStateBuf2,nStateBufSize);

	Acquire();

	m_hWnd = hWnd;
}

//	J
void CMglDirectInputDeviceBase::Release()
{
	if( m_pDevice )
        Unacquire();
    
    // Release any DirectInput objects.
    SAFE_RELEASE( m_pDevice );
}


//	foCXւ̃ANZX擾
void CMglDirectInputDeviceBase::Acquire()
{
	InitCheck();
	//	EChEtH[JXOĂ鎞̓G[Ԃ
	m_pDevice->Acquire();
/*
	MyuAssert( m_pDevice->Acquire(), DI_OK,
		"CMglDirectInputDeviceBase::Acquire()  m_pDevice->Acquire()Ɏs" );
*/
}

//	foCXւ̃ANZXj
void CMglDirectInputDeviceBase::Unacquire()
{
	InitCheck();
	m_pDevice->Unacquire();
}

//	Xe[g擾
BYTE* CMglDirectInputDeviceBase::UpdateStateBuf()
{
	//	2008/09/29  Âobt@L
	/*SAFE_DELETE_ARY(m_pStateBuf2);
	m_pStateBuf2 = m_pStateBuf;*/
	SwapStateBuf();

	InitCheck();
	ZeroMemory( m_pStateBuf, m_nStateBufSize );
	if ( m_pDevice->GetDeviceState( m_nStateBufSize, m_pStateBuf ) != DI_OK )
	{
		//	sAcquire()sĂ񎎂Ă݂
		Acquire();
		if ( m_pDevice->GetDeviceState( m_nStateBufSize, m_pStateBuf ) != DI_OK ){
			ZeroMemory( m_pStateBuf, m_nStateBufSize );
			return NULL;
		}

		/*
			PɃEChEtH[JXOĂ邾Ȃ̂ŉȂ
		*/

		//	ǂ擾ɎsAgĂ܂Ă悤B
		//ZeroMemory( m_pStateBuf, m_nStateBufSize );
		//	-- 2008/01/19 GetDeviceState()ŐĂꍇZeroMemoryĂ͂Ȃ悤ȁEEEH
	}

	return m_pStateBuf;
}

//	0:ωȂ  ̒l:ꂽ  ̒l:ꂽ
int CMglDirectInputDeviceBase::GetStateChanged(int nIndex)
{
	return m_pStateBuf[nIndex] - m_pStateBuf2[nIndex];
}